# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .generation_meta_item import GenerationMetaItem
from .single_generation import SingleGeneration


class Generation(pydantic.BaseModel):
    id: str
    prompt: typing.Optional[str] = pydantic.Field(description=("Prompt used for generations.\n"))
    generations: typing.List[SingleGeneration] = pydantic.Field(description=("List of generated results\n"))
    meta: typing.Optional[typing.List[GenerationMetaItem]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
